%define project gtk2hs

%define ghc_version 6.4.2
%define ghcver ghc642
%define mozver 37:1.7.12

%define build_mozembed 1
%define build_cairo 1

Summary: A Haskell GUI library based on the Gtk+ GUI toolkit
Name: ghc-%{project}
Version: 0.9.10
Release: 2%{?dist}
License: LGPL
Group: Development/Libraries
Source: %{project}-%{version}.tar.gz
URL: http://gtk2hs.sourceforge.net/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: %{ghcver}, %{_bindir}/hsc2hs, haddock
BuildRequires: gtk2-devel, gtksourceview-devel, libglade2-devel, GConf2-devel
%if %{build_mozembed}
BuildRequires: mozilla-devel = %{mozver}
%endif
%if %{build_cairo}
BuildRequires: cairo-devel
%endif
Requires: ghc = %{ghc_version}, %{ghcver}-gtk = %{version}-%{release}

%description
A Gtk+ binding for the functional language Haskell featuring
automatic memory management, unicode support, and wide
coverage of Gtk+ 2 widgets.

%package -n %{ghcver}-gtk
Summary: A Haskell GUI library based on the Gtk+ GUI toolkit
Group: Development/Libraries
Requires: %{ghcver}, %{ghcver}-glib = %{version}-%{release}
%if %{build_cairo}
Requires: %{ghcver}-cairo = %{version}-%{release}
%endif
Requires: gtk2-devel
PreReq: %{_bindir}/ghc-pkg-%{ghc_version}

%description -n %{ghcver}-gtk
A Gtk+ binding for the functional language Haskell featuring
automatic memory management, unicode support, and wide
coverage of Gtk+ 2 widgets.

This package contains the libraries compiled for ghc-%{ghc_version}.


%if %{build_cairo}
%package -n %{ghcver}-cairo
Summary: Haskell binding for cairo
Group: Development/Libraries
Requires: %{ghcver}, %{ghcver}-glib = %{version}-%{release}
PreReq: %{_bindir}/ghc-pkg-%{ghc_version}

%description -n %{ghcver}-cairo
A cairo binding for gtk2hs.
%endif


%package doc
Summary: Haskell Gtk+ GUI library documentation
Group: Development/Libraries

%description doc
A Gtk+ binding for the functional language Haskell featuring
automatic memory management, unicode support, and wide
coverage of Gtk+ 2 widgets.

This package contains the gtk2hs documentation.


%package -n %{ghcver}-gconf
Summary: Haskell binding for GConf
Group: Development/Libraries
Requires: %{ghcver}
Requires: %{ghcver}-glib = %{version}-%{release}, GConf2-devel
PreReq: %{_bindir}/ghc-pkg-%{ghc_version}

%description -n %{ghcver}-gconf
A GConf binding for gtk2hs.

This package is compiled for ghc-%{ghc_version}.


%package -n %{ghcver}-glade
Summary: Haskell binding of glade for gtk2hs.
Group: Development/Libraries
Requires: %{ghcver}
Requires: libglade2-devel
PreReq: %{_bindir}/ghc-pkg-%{ghc_version}

%description -n %{ghcver}-glade
A Glade2 binding for gtk2hs.

This package is compiled for ghc-%{ghc_version}.


%package -n %{ghcver}-glib
Summary: Haskell binding for glib
Group: Development/Libraries
Requires: %{ghcver}
Requires: glib-devel
PreReq: %{_bindir}/ghc-pkg-%{ghc_version}

%description -n %{ghcver}-glib
A glib binding for gtk2hs.


%package -n %{ghcver}-mogul
Summary: A Haskell GUI library based on the Gtk+ GUI toolkit
Group: Development/Libraries
Requires: %{ghcver}, %{ghcver}-gtk = %{version}-%{release}
PreReq: %{_bindir}/ghc-pkg-%{ghc_version}

%description -n %{ghcver}-mogul
A Gtk+ binding for the functional language Haskell featuring
automatic memory management, unicode support, and wide
coverage of Gtk+ 2 widgets.

This package contains the libraries compiled for ghc-%{ghc_version}.


%if %{build_mozembed}
%package -n %{ghcver}-mozembed
Summary: Haskell binding for gtkembedmoz
Group: Development/Libraries
Requires: %{ghcver}
Requires: %{ghcver}-gtk = %{version}-%{release}, mozilla-devel = %{mozver}
PreReq: %{_bindir}/ghc-pkg-%{ghc_version}

%description -n %{ghcver}-mozembed
A GtkEmbedMoz binding for gtk2hs.
%endif


%package -n %{ghcver}-sourceview
Summary: Haskell binding for gtksourceview
Group: Development/Libraries
Requires: %{ghcver}
Requires: %{ghcver}-gtk = %{version}-%{release}, gtksourceview-devel
PreReq: %{_bindir}/ghc-pkg-%{ghc_version}

%description -n %{ghcver}-sourceview
A GtkSourceView binding for gtk2hs.

This package is compiled for ghc-%{ghc_version}.


# the debuginfo subpackage is currently empty anyway, so don't generate it
%define debug_package %{nil}
%define __spec_install_post /usr/lib/rpm/brp-compress

%define ghclibdir %{_libdir}/ghc/%{ghc_version}
%define gtk2hsdir %{ghclibdir}/gtk2hs


%prep
%setup -q -n %{project}-%{version}


%build
%configure --with-hc=ghc-%{ghc_version} --prefix=%{_prefix} --libdir=%{ghclibdir} --enable-packager-mode --enable-docs --enable-libglade --enable-gconf --enable-sourceview \
%if %{build_mozembed}
	--enable-mozilla \
%endif
%if %{build_cairo}
	--enable-cairo
%endif

LANG=C make all


%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} install


%clean
rm -rf %{buildroot}


%define ghcpkg_inst() ghc-pkg-%{ghc_version} update --auto-ghci-libs  %{gtk2hsdir}/%{1}.package.conf &>/dev/null

%define ghcpkg_uninst() rm -f  %{gtk2hsdir}/HS%{1}.o ; ghc-pkg-%{ghc_version} unregister %{1} &>/dev/null || :


%post -n %{ghcver}-gtk
%{ghcpkg_inst gtk}


%if %{build_cairo}
%post -n %{ghcver}-cairo
%{ghcpkg_inst cairo}
%endif


%post -n %{ghcver}-gconf
%{ghcpkg_inst gconf}


%post -n %{ghcver}-glade
%{ghcpkg_inst glade}


%post -n %{ghcver}-glib
%{ghcpkg_inst glib}


%post -n %{ghcver}-mogul
%{ghcpkg_inst mogul}


%if %{build_mozembed}
%post -n %{ghcver}-mozembed
%{ghcpkg_inst mozembed}
%endif


%post -n %{ghcver}-sourceview
%{ghcpkg_inst sourceview}


%preun -n %{ghcver}-gtk
if [ "$1" = 0 ]; then
  %{ghcpkg_uninst gtk}
fi


%if %{build_cairo}
%preun -n %{ghcver}-cairo
if [ "$1" = 0 ]; then
  %{ghcpkg_uninst cairo}
fi
%endif


%preun -n %{ghcver}-gconf
if [ "$1" = 0 ]; then
  %{ghcpkg_uninst gconf}
fi


%preun -n %{ghcver}-glade
if [ "$1" = 0 ]; then
  %{ghcpkg_uninst glade}
fi


%preun -n %{ghcver}-glib
if [ "$1" = 0 ]; then
  %{ghcpkg_uninst glib}
fi


%preun -n %{ghcver}-mogul
if [ "$1" = 0 ]; then
  %{ghcpkg_uninst mogul}
fi


%if %{build_mozembed}
%preun -n %{ghcver}-mozembed
if [ "$1" = 0 ]; then
  %{ghcpkg_uninst mozembed}
fi
%endif


%preun -n %{ghcver}-sourceview
if [ "$1" = 0 ]; then
  %{ghcpkg_uninst sourceview}
fi


%files
%defattr(-,root,root)


%files -n %{ghcver}-gtk
%defattr(-,root,root)
%doc ChangeLog TODO AUTHORS COPYING.LIB
%dir %{ghclibdir}
%dir %{gtk2hsdir}
%{gtk2hsdir}/gtk.package.conf
%{gtk2hsdir}/libHSgtk.a
%dir %{gtk2hsdir}/imports
%{gtk2hsdir}/imports/gtk


%if %{build_cairo}
%files -n %{ghcver}-cairo
%defattr(-,root,root)
%dir %{ghclibdir}
%dir %{gtk2hsdir}
%{gtk2hsdir}/cairo.package.conf
%{gtk2hsdir}/libHScairo.a
%dir %{gtk2hsdir}/imports
%{gtk2hsdir}/imports/cairo
%endif


%files doc
%defattr(-,root,root)
%{_defaultdocdir}/gtk2hs


%files -n %{ghcver}-gconf
%defattr(-,root,root)
%dir %{ghclibdir}
%dir %{gtk2hsdir}
%{gtk2hsdir}/gconf.package.conf
%{gtk2hsdir}/libHSgconf.a
%dir %{gtk2hsdir}/imports
%{gtk2hsdir}/imports/gconf


%files -n %{ghcver}-glade
%defattr(-,root,root)
%dir %{ghclibdir}
%dir %{gtk2hsdir}
%{gtk2hsdir}/glade.package.conf
%{gtk2hsdir}/libHSglade.a
%dir %{gtk2hsdir}/imports
%{gtk2hsdir}/imports/glade


%files -n %{ghcver}-glib
%defattr(-,root,root)
%dir %{ghclibdir}
%dir %{gtk2hsdir}
%{gtk2hsdir}/glib.package.conf
%{gtk2hsdir}/libHSglib.a
%dir %{gtk2hsdir}/imports
%{gtk2hsdir}/imports/glib
%dir %{gtk2hsdir}/include
%{gtk2hsdir}/include/gtk2hs-config.h


%files -n %{ghcver}-mogul
%defattr(-,root,root)
%dir %{ghclibdir}
%dir %{gtk2hsdir}
%{gtk2hsdir}/mogul.package.conf
%{gtk2hsdir}/libHSmogul.a
%dir %{gtk2hsdir}/imports
%{gtk2hsdir}/imports/mogul


%if %{build_mozembed}
%files -n %{ghcver}-mozembed
%defattr(-,root,root)
%dir %{ghclibdir}
%dir %{gtk2hsdir}
%{gtk2hsdir}/mozembed.package.conf
%{gtk2hsdir}/libHSmozembed.a
%dir %{gtk2hsdir}/imports
%{gtk2hsdir}/imports/mozembed
%endif


%files -n %{ghcver}-sourceview
%defattr(-,root,root)
%dir %{ghclibdir}
%dir %{gtk2hsdir}
%{gtk2hsdir}/sourceview.package.conf
%{gtk2hsdir}/libHSsourceview.a
%dir %{gtk2hsdir}/imports
%{gtk2hsdir}/imports/sourceview
#%%{_datadir}/gtksourceview-1.0/language-specs


%changelog
* Tue Apr 25 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-2
- use module names for the subpackages
- subpackage mogul
- own the include dir

* Sat Apr 22 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-1
- initial packaging for Fedora Extras
- define ghcpkg_inst and ghcpkg_uninst for post and preun scripts and
  silence ghc-pkg
- own include/

* Wed Oct 26 2005 Jens Petersen <petersen@redhat.com> - 0.9.9.7-0
- rc

* Wed Sep 21 2005 Jens Petersen <petersen@redhat.com> - 0.9.9-2
- build with ghc-6.4.1

* Sat Jul 30 2005 Jens Petersen <petersen@redhat.com> - 0.9.8-3
- drop old conflicts

* Tue Jul  5 2005 Jens Petersen <petersen@redhat.com> - 0.9.8-2
- use %%configure to configure for arch to avoid gclosure ghci-6.4 linking
  problems on i386

* Wed Jun 22 2005 Jens Petersen <petersen@haskell.org> - 0.9.8-1
- update to 0.9.8
- use new --enable-packager-mode and --enable-* configure options

* Thu Jun  9 2005 Jens Petersen <petersen@haskell.org> - 0.9.7.91
- update to rc1
- add build_mozembed macro and use it

* Mon May  9 2005 Jens Petersen <petersen@haskell.org> - 0.9.7-2
- add gtk2hs-0.9.7-ghc64.patch and build with ghc-6.4 (Duncan Coutts)
  - .pkg files are now .cabal files

* Tue Jan 18 2005 Duncan Coutts <duncan@coutts.uklinux.net>
- cleanup requirements, summaries, descriptions, and configure invocation
- update preun scripts

* Thu Aug 19 2004 Jens Petersen <petersen@haskell.org>
- use suffix -ghc621 instead of -ghc6.2.1 and conflict with old packages
- buildrequire ghc-doc and gtk2hs-doc-ghc621 requires ghc-doc
- move docs and demo files to %{_defaultdocdir}/gtk2hs

* Mon Aug 16 2004 Jens Petersen <petersen@haskell.org>
- update to 0.9.6

* Thu Jul 22 2004 Jens Petersen <petersen@haskell.org>
- split sourceview and glade into separate subpackages
- require -devel packages rather than lib pkg for gtk2, gtksourceview,
  and libglade2

* Wed Mar 24 2004 Jens Petersen <petersen@haskell.org>
- enable gtksourceview and glade configure options
- use mkdir -p instead of mkdirhier
- update file locations in %%post and %%preun scripts
- buildrequire libglade2-devel

* Tue Nov 11 2003 Jens Petersen <petersen@haskell.org>
- use %%c2hs instead of "--with c2hs" to configure c2hs program
- clean demo to avoid binary files in docs dir

* Mon Nov  3 2003 Jens Petersen <petersen@haskell.org>
- add sourceview package to %%post and %%preun
- install gtksourceview haskell.lang language-spec

* Thu Jul 31 2003 Jens Petersen <petersen@haskell.org>
- build with ghc-6.0.1
- put demo dir in docs dir rather than individual source files

* Thu Jul 10 2003 Jens Petersen <petersen@haskell.org>
- build with ghc-6.0
- name ghc subpackage "ghc%%{ghc_version}"

* Wed Jun 18 2003 Jens Petersen <petersen@haskell.org>
- require and buildrequire %{_bindir}/ghc-%%{ghc_version}

* Wed May 21 2003 Jens Petersen <petersen@haskell.org>
- add -g option to ghc-pkg -u so that ghci object gets generated
- delete them when uninstalling
- build and include mogul documentation

* Thu May 15 2003 Jens Petersen <petersen@haskell.org>
- use new DESTDIR make variable, so no longer need to fix config files in post
- remove buildroot before install
- build and include gtk docs

* Fri Jan 10 2003 Jens Petersen <petersen@haskell.org>
- made into .spec.in file
- let configure set the version
- update description
- introduce --with-c2hs rpmbuild option
- use perl to remove buildroot traces from package conf files
- simplify ghc-pkg update commands

* Tue Dec 17 2002 Jens Petersen <petersen@haskell.org>
- latest cvs with ghc 5.04.2

* Thu Sep 26 2002 Jens Petersen
- build with ghc-5.04.1

* Fri Aug  2 2002 Jens Petersen
- only include demo source in doc dir

* Fri Jul 26 2002 Jens Petersen
- build with ghc-5.04
- cvs update

* Wed Jul 10 2002 Jens Petersen
- my current branch

* Wed May  1 2002 Jens Petersen
- patch TreeViewColumn.chs to make it usable

* Tue Apr 23 2002 Jens Petersen
- 0.9.0
- update gtk2 and mogul ghc-pkg entries on upgrade

* Fri Apr 12 2002 Jens Petersen
- adapt for gtk2hs
- fix mk files for buildroot install
- post and postun scriptlets for pkg config

* Tue Mar 12 2002 Manuel Chakravarty
- require a specific Haskell compiler (namely, the one for which the packages 
  was compiled)

* Sat Feb 17 2001 Manuel Chakravarty
- derived from C->Haskell's .spec file
